
#include "unix.h"

typedef struct _Point {
    float x, y, z;
} Point;


Snub_cube()
{
    FILE *fp;
    extern char *filename;
    extern char creatingObject;
    creatingObject = 0;

    filename = (char *) malloc( strlen((const char *)getenv("OBJ_PATH")) + 20 );
    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), "snub_cube.geom" );
    fp = fopen( filename, "w" );

    fprintf( fp, "24\t38\t40\n" );

    /* Print the Coordinates of the points */
    fprintf( fp, "0.295598 -1 -0.543689\n" );
    fprintf( fp, "1 -0.295598 0.543689\n" );
    fprintf( fp, "1 -0.543689 -0.295598\n" );
    fprintf( fp, "0.295598 -0.543689 1\n" );
    fprintf( fp, "0.543689 0.295598 1\n" );
    fprintf( fp, "0.543689 -1 0.295598\n" );
    fprintf( fp, "0.295598 1 0.543689\n" );
    fprintf( fp, "-0.295598 1 -0.543689\n" );
    fprintf( fp, "-1 0.543689 -0.295598\n" );
    fprintf( fp, "-1 -0.295598 -0.543689\n" );
    fprintf( fp, "-0.543689 0.295598 -1\n" );
    fprintf( fp, "-0.543689 -1 -0.295598\n" );
    fprintf( fp, "-0.295598 -0.543689 -1\n" );
    fprintf( fp, "0.543689 -0.295598 -1\n" );
    fprintf( fp, "-0.295598 -1 0.543689\n" );
    fprintf( fp, "1 0.543689 0.295598\n" );
    fprintf( fp, "-0.543689 -0.295598 1\n" );
    fprintf( fp, "-1 -0.543689 0.295598\n" );
    fprintf( fp, "-1 0.295598 0.543689\n" );
    fprintf( fp, "-0.543689 1 0.295598\n" );
    fprintf( fp, "-0.295598 0.543689 1\n" );
    fprintf( fp, "0.295598 0.543689 -1\n" );
    fprintf( fp, "0.543689 1 -0.295598\n" );
    fprintf( fp, "1 0.295598 -0.543689\n" );

    /* Print the Conectivity data of the points */
    fprintf( fp, "4 4 20 16 3\n" );
    fprintf( fp, "4 5 14 11 0\n" );
    fprintf( fp, "4 15 1 2 23\n" );
    fprintf( fp, "3 14 3 16\n" );
    fprintf( fp, "3 14 5 3\n" );
    fprintf( fp, "3 3 5 1\n" );
    fprintf( fp, "3 3 1 4\n" );
    fprintf( fp, "3 4 1 15\n" );
    fprintf( fp, "3 5 2 1\n" );
    fprintf( fp, "3 5 0 2\n" );
    fprintf( fp, "4 10 21 13 12\n" );
    fprintf( fp, "4 19 6 22 7\n" );
    fprintf( fp, "4 17 18 8 9\n" );
    fprintf( fp, "3 7 22 21\n" );
    fprintf( fp, "3 7 21 10\n" );
    fprintf( fp, "3 8 7 10\n" );
    fprintf( fp, "3 8 10 9\n" );
    fprintf( fp, "3 9 10 12\n" );
    fprintf( fp, "3 13 0 12\n" );
    fprintf( fp, "3 12 0 11\n" );
    fprintf( fp, "3 23 2 13\n" );
    fprintf( fp, "3 21 23 13\n" );
    fprintf( fp, "3 13 2 0\n" );
    fprintf( fp, "3 11 14 17\n" );
    fprintf( fp, "3 20 6 19\n" );
    fprintf( fp, "3 6 20 4\n" );
    fprintf( fp, "3 22 15 23\n" );
    fprintf( fp, "3 6 15 22\n" );
    fprintf( fp, "3 6 4 15\n" );
    fprintf( fp, "3 14 16 17\n" );
    fprintf( fp, "3 18 17 16\n" );
    fprintf( fp, "3 18 16 20\n" );
    fprintf( fp, "3 12 11 9\n" );
    fprintf( fp, "3 8 19 7\n" );
    fprintf( fp, "3 18 19 8\n" );
    fprintf( fp, "3 20 19 18\n" );
    fprintf( fp, "3 11 17 9\n" );
    fprintf( fp, "3 21 22 23\n" );

    fclose( fp );

    filename = (char *) malloc( strlen((const char *)getenv("OBJ_PATH")) + 20 );
    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), "snub_cube.aoff" );
    fp = fopen( filename, "w" );

    fprintf( fp, "geometry\tindexed_poly\tfff\t\t%s\n", "snub_cube.geom" );
    fprintf( fp, "connect_offset\tdefault\t\tf\t\t0\n" );

    fclose( fp );
}
